/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the CampaignCondition type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CampaignCondition{}

// CampaignCondition struct for CampaignCondition
type CampaignCondition struct {
	Operator string `json:"operator"`
	// required unless operator: or, and
	DataType *string `json:"data_type,omitempty"`
	Left *ConditionExpression `json:"left,omitempty"`
	Right *ConditionExpression `json:"right,omitempty"`
	Conditions []CampaignCondition `json:"conditions,omitempty"`
}

// NewCampaignCondition instantiates a new CampaignCondition object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCampaignCondition(operator string) *CampaignCondition {
	this := CampaignCondition{}
	this.Operator = operator
	return &this
}

// NewCampaignConditionWithDefaults instantiates a new CampaignCondition object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCampaignConditionWithDefaults() *CampaignCondition {
	this := CampaignCondition{}
	return &this
}

// GetOperator returns the Operator field value
func (o *CampaignCondition) GetOperator() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Operator
}

// GetOperatorOk returns a tuple with the Operator field value
// and a boolean to check if the value has been set.
func (o *CampaignCondition) GetOperatorOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Operator, true
}

// SetOperator sets field value
func (o *CampaignCondition) SetOperator(v string) {
	o.Operator = v
}

// GetDataType returns the DataType field value if set, zero value otherwise.
func (o *CampaignCondition) GetDataType() string {
	if o == nil || IsNil(o.DataType) {
		var ret string
		return ret
	}
	return *o.DataType
}

// GetDataTypeOk returns a tuple with the DataType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CampaignCondition) GetDataTypeOk() (*string, bool) {
	if o == nil || IsNil(o.DataType) {
		return nil, false
	}
	return o.DataType, true
}

// HasDataType returns a boolean if a field has been set.
func (o *CampaignCondition) HasDataType() bool {
	if o != nil && !IsNil(o.DataType) {
		return true
	}

	return false
}

// SetDataType gets a reference to the given string and assigns it to the DataType field.
func (o *CampaignCondition) SetDataType(v string) {
	o.DataType = &v
}

// GetLeft returns the Left field value if set, zero value otherwise.
func (o *CampaignCondition) GetLeft() ConditionExpression {
	if o == nil || IsNil(o.Left) {
		var ret ConditionExpression
		return ret
	}
	return *o.Left
}

// GetLeftOk returns a tuple with the Left field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CampaignCondition) GetLeftOk() (*ConditionExpression, bool) {
	if o == nil || IsNil(o.Left) {
		return nil, false
	}
	return o.Left, true
}

// HasLeft returns a boolean if a field has been set.
func (o *CampaignCondition) HasLeft() bool {
	if o != nil && !IsNil(o.Left) {
		return true
	}

	return false
}

// SetLeft gets a reference to the given ConditionExpression and assigns it to the Left field.
func (o *CampaignCondition) SetLeft(v ConditionExpression) {
	o.Left = &v
}

// GetRight returns the Right field value if set, zero value otherwise.
func (o *CampaignCondition) GetRight() ConditionExpression {
	if o == nil || IsNil(o.Right) {
		var ret ConditionExpression
		return ret
	}
	return *o.Right
}

// GetRightOk returns a tuple with the Right field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CampaignCondition) GetRightOk() (*ConditionExpression, bool) {
	if o == nil || IsNil(o.Right) {
		return nil, false
	}
	return o.Right, true
}

// HasRight returns a boolean if a field has been set.
func (o *CampaignCondition) HasRight() bool {
	if o != nil && !IsNil(o.Right) {
		return true
	}

	return false
}

// SetRight gets a reference to the given ConditionExpression and assigns it to the Right field.
func (o *CampaignCondition) SetRight(v ConditionExpression) {
	o.Right = &v
}

// GetConditions returns the Conditions field value if set, zero value otherwise.
func (o *CampaignCondition) GetConditions() []CampaignCondition {
	if o == nil || IsNil(o.Conditions) {
		var ret []CampaignCondition
		return ret
	}
	return o.Conditions
}

// GetConditionsOk returns a tuple with the Conditions field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CampaignCondition) GetConditionsOk() ([]CampaignCondition, bool) {
	if o == nil || IsNil(o.Conditions) {
		return nil, false
	}
	return o.Conditions, true
}

// HasConditions returns a boolean if a field has been set.
func (o *CampaignCondition) HasConditions() bool {
	if o != nil && !IsNil(o.Conditions) {
		return true
	}

	return false
}

// SetConditions gets a reference to the given []CampaignCondition and assigns it to the Conditions field.
func (o *CampaignCondition) SetConditions(v []CampaignCondition) {
	o.Conditions = v
}

func (o CampaignCondition) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CampaignCondition) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["operator"] = o.Operator
	if !IsNil(o.DataType) {
		toSerialize["data_type"] = o.DataType
	}
	if !IsNil(o.Left) {
		toSerialize["left"] = o.Left
	}
	if !IsNil(o.Right) {
		toSerialize["right"] = o.Right
	}
	if !IsNil(o.Conditions) {
		toSerialize["conditions"] = o.Conditions
	}
	return toSerialize, nil
}

type NullableCampaignCondition struct {
	value *CampaignCondition
	isSet bool
}

func (v NullableCampaignCondition) Get() *CampaignCondition {
	return v.value
}

func (v *NullableCampaignCondition) Set(val *CampaignCondition) {
	v.value = val
	v.isSet = true
}

func (v NullableCampaignCondition) IsSet() bool {
	return v.isSet
}

func (v *NullableCampaignCondition) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCampaignCondition(val *CampaignCondition) *NullableCampaignCondition {
	return &NullableCampaignCondition{value: val, isSet: true}
}

func (v NullableCampaignCondition) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCampaignCondition) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


